Bug 997478 - Review Request: sugar-runner - Sugar runner emulator for development
Review Request: sugar-runner - Sugar runner emulator for development
Status: CLOSED NEXTRELEASE
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
Unspecified Unspecified
unspecified Severity unspecified
: ---
: ---
Assigned To: Haïkel Guémar
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2013-08-15 09:48 EDT by Peter Robinson
Modified: 2013-10-09 07:14 EDT (History)
4 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2013-10-09 07:14:15 EDT
Type: Bug
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
karlthered: fedora‑review+
limburgher: fedora‑cvs+


Attachments (Terms of Use)

  None (edit)
Description Peter Robinson 2013-08-15 09:48:19 EDT
SPEC: http://pbrobinson.fedorapeople.org/sugar-runner.spec
SRPM: http://pbrobinson.fedorapeople.org/sugar-runner-0.99.3-1.fc19.src.rpm

Description:
sugar-runner allows to run sugar without using a display manager as usually
required by X desktops. You can run it either from a text console
or from inside another X session. By default it runs fullscreen but when inside
X you can specify the window size using the --resolution option.
Comment 1 Peter Robinson 2013-08-15 09:59:26 EDT
koji scratch build: http://koji.fedoraproject.org/koji/taskinfo?taskID=5818889
Comment 2 Mario Blättermann 2013-08-25 12:49:27 EDT
Some build requirements can be dropped:

glib2-devel (needed by gobject-introspection-devel)
libXrandr-devel (needed by libX11-devel)


%package devel
...
Requires: pkgconfig

An explicite requirement for pkgconfig is probably not needed. Have a look at what rpm found automatically. I'm pretty sure that it is already included, if it is really needed. In case of rpm haven't found it, why do you need this? There's no *.pc file in the package.

The icon cache needs to be updated when installing icons under %{_datadir}/icons/:
https://fedoraproject.org/wiki/Archive:PackagingDrafts/ScriptletSnippets/iconcache?rd=PackagingDrafts/ScriptletSnippets/iconcache#GTK.2B_icon_cache
Comment 3 Baptiste Mille-Mathias 2013-09-02 16:16:10 EDT
Hello, 

As required by the process for wannabe-packagers, I'm doing an informal review (which has to be backed up by my sponsor Haïkel Guemar).

I ran fedora-review backed by a manual review. 

Corrections & Suggestions
=========================
- License field: not only GPLv2+ but also LGPLv2+, note the FSF address is the old one on those files:
 * /lib/sugar-runner-window.c
 * /lib/sugar-runner-window.h
 * /lib/sugar-runner.c
 * /lib/sugar-runner.h
- gtk-update-icon-cache is not run when installing/uninstalling the package, see http://fedoraproject.org/wiki/Packaging:ScriptletSnippets#Icon_Cache (as said in the previous comment)
- I wonder if you wouldn't be better to have to Requires defined (at least sugar), because when I tried to launch the binary sugar-runner it crashed with the error
  File "/usr/bin/sugar-runner", line 28, in <module>
    from gi.repository import SugarRunner
ImportError: No module named gi.repository
- "sed -i 's/Teaching/X-Teaching/' data/sugar-runner.desktop" I guess you already did that, but you'd better report the bugfix upstream.

Thanks for your answers.

Regards

Please find hereunder the complete output of fedora-review.

===== MUST items =====

C/C++:
[-]: Package does not contain kernel modules.
[-]: Package contains no static executables.
[x]: ldconfig called in %post and %postun if required.
[x]: Package does not contain any libtool archives (.la)
[x]: Rpath absent or only used for internal libs.
[x]: Development (unversioned) .so files in -devel subpackage, if present.

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: %build honors applicable compiler flags or justifies otherwise.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[x]: Development files must be in a -devel package
[x]: Package requires other packages for directories it uses.
[x]: Package uses nothing in %doc for runtime.
[x]: Package is not known to require ExcludeArch.
[x]: Package complies to the Packaging Guidelines
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses found:
     "GPL (v2 or later)", "LGPL (v2 or later) (with incorrect FSF address)".
[x]: License file installed when any subpackage combination is installed.
[x]: Package consistently uses macro is (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[-]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[!]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: update-desktop-database is invoked when required
     Note: desktop file(s) in sugar-runner
[x]: Useful -debuginfo package or justification otherwise.
[-]: Large documentation must go in a -doc subpackage.
     Note: Documentation size is 30720 bytes in 1 files.
[x]: All build dependencies are listed in BuildRequires, except for any that
     are listed in the exceptions section of Packaging Guidelines.
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Each %files section contains %defattr if rpm < 4.4
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Package contains desktop file if it is a GUI application.
[x]: Package installs a %{name}.desktop using desktop-file-install if there is
     such a file.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Fully versioned dependency in subpackages, if present.
[x]: If (and only if) the source package includes the text of the license(s)
     in its own file, then that file, containing the text of the license(s)
     for the package is included in %doc.
[x]: Package use %makeinstall only when make install' ' DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package do not use a name that already exist
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as provided
     in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local
[x]: Package successfully compiles and builds into binary rpms on at least one
     supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate file
     from upstream, the packager SHOULD query upstream to include it.
[-]: Final provides and requires are sane (see attachments).
[x]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[-]: Scriptlets must be sane, if used.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[-]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed files.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: Dist tag is present.
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Uses parallel make.
[x]: SourceX tarball generation or download is documented.
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define.

Rpmlint
-------
Checking: sugar-runner-0.99.3-1.fc20.x86_64.rpm
          sugar-runner-devel-0.99.3-1.fc20.x86_64.rpm
sugar-runner.x86_64: W: spelling-error %description -l en_US fullscreen -> full screen, full-screen, firescreen
sugar-runner.x86_64: W: no-manual-page-for-binary sugar-runner
sugar-runner-devel.x86_64: W: no-documentation
2 packages and 0 specfiles checked; 0 errors, 3 warnings.




Rpmlint (installed packages)
----------------------------
# rpmlint sugar-runner sugar-runner-devel
sugar-runner.x86_64: W: spelling-error %description -l en_US fullscreen -> full screen, full-screen, firescreen
sugar-runner.x86_64: W: no-manual-page-for-binary sugar-runner
sugar-runner-devel.x86_64: W: no-documentation
2 packages and 0 specfiles checked; 0 errors, 3 warnings.
# echo 'rpmlint-done:'



Diff spec file in url and in SRPM
---------------------------------
--- /home/baptistemm/Code/Fedora/reviews/997478-sugar-runner/srpm/sugar-runner.spec	2013-08-26 22:08:02.770811963 +0200
+++ /home/baptistemm/Code/Fedora/reviews/997478-sugar-runner/srpm-unpacked/sugar-runner.spec	2013-08-26 22:08:02.995812752 +0200
@@ -2,5 +2,5 @@
 Version:       0.99.3
 Release:       1%{?dist}
-Summary:       Sugar runner emulator for development
+Summary:       Browse activity for Sugar
 Group:         User Interface/Desktops
 License:       GPLv2+


Requires
--------
sugar-runner (rpmlib, GLIBC filtered):
    /sbin/ldconfig
    /usr/bin/python
    libX11.so.6()(64bit)
    libXrandr.so.2()(64bit)
    libc.so.6()(64bit)
    libglib-2.0.so.0()(64bit)
    rtld(GNU_HASH)

sugar-runner-devel (rpmlib, GLIBC filtered):
    libsugarrunner.so.0()(64bit)
    pkgconfig
    sugar-runner(x86-64)
Comment 4 Peter Robinson 2013-09-02 17:09:20 EDT
SPEC: http://pbrobinson.fedorapeople.org/sugar-runner.spec
SRPM: http://pbrobinson.fedorapeople.org/sugar-runner-0.99.3-2.fc19.src.rpm

Updated, thanks for the feedback
Comment 5 Haïkel Guémar 2013-09-08 04:29:32 EDT
As Baptiste package sponsor, i'll take care of the formal review (see below)

I hereby approve this package into Fedora Packages Collection as it respects our guidelines.
Please proceed with scm request, and make sure that the FSF incorrect address issue in LGPLv2+
has been reported upstream.

@baptiste: you did well for this review



Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed



===== MUST items =====

C/C++:
[x]: Package does not contain kernel modules.
[x]: Package contains no static executables.
[x]: ldconfig called in %post and %postun if required.
[x]: Package does not contain any libtool archives (.la)
[x]: Rpath absent or only used for internal libs.
[x]: Development (unversioned) .so files in -devel subpackage, if present.

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.

=> technically, the library is LGPLv2+ and could be reused by another program.
Since there's no documentation, and that no other programs uses it, i'll consider it's intended
for internal use only
 
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses found:
     "GPL (v2 or later)", "LGPL (v2 or later) (with incorrect FSF address)".
     Detailed output of licensecheck in /home/haikel/997478-sugar-
     runner/licensecheck.txt

=> source files in lib directory have all an incorrect LGPLv2+ header, according Fedora Legal, it should be reported upstream.

[x]: License file installed when any subpackage combination is installed.
[x]: Package must own all directories that it creates.
     Note: Directories without known owners:
     /usr/share/icons/hicolor/scalable/apps, /usr/lib64/girepository-1.0,
     /usr/share/icons/hicolor, /usr/share/icons/hicolor/scalable,
     /usr/share/gir-1.0
[x]: %build honors applicable compiler flags or justifies otherwise.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[x]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: gtk-update-icon-cache is invoked in %postun and %posttrans if package
     contains icons.
     Note: icons in sugar-runner
[x]: Useful -debuginfo package or justification otherwise.
[x]: Package is not known to require an ExcludeArch tag.
[-]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 30720 bytes in 1 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least one
     supported primary architecture.

=> scratch build: http://koji.fedoraproject.org/koji/taskinfo?taskID=5909827
     
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the license(s)
     in its own file, then that file, containing the text of the license(s)
     for the package is included in %doc.
[x]: Package requires other packages for directories it uses.
[x]: Package does not own files or directories owned by other packages.
[x]: All build dependencies are listed in BuildRequires, except for any that
     are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Each %files section contains %defattr if rpm < 4.4
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Package contains desktop file if it is a GUI application.
[x]: Package installs a %{name}.desktop using desktop-file-install or desktop-
     file-validate if there is such a file.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install' ' DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package do not use a name that already exist
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as provided
     in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate file
     from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[x]: Package functions as described.

=> tried both the launch script and introspection module (through python), works fine

[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[-]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed files.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: Dist tag is present (not strictly required in GL).
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Fully versioned dependency in subpackages if applicable.
[x]: Uses parallel make %{?_smp_mflags} macro.
[x]: SourceX tarball generation or download is documented.
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Large data in /usr/share should live in a noarch subpackage if package is
     arched.
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: sugar-runner-0.99.3-2.fc18.x86_64.rpm
          sugar-runner-devel-0.99.3-2.fc18.x86_64.rpm
          sugar-runner-0.99.3-2.fc18.src.rpm
sugar-runner.x86_64: W: spelling-error %description -l en_US fullscreen -> full screen, full-screen, firescreen
sugar-runner.x86_64: W: no-manual-page-for-binary sugar-runner
sugar-runner-devel.x86_64: W: no-documentation
sugar-runner.src: W: spelling-error %description -l en_US fullscreen -> full screen, full-screen, firescreen
3 packages and 0 specfiles checked; 0 errors, 4 warnings.




Rpmlint (installed packages)
----------------------------
# rpmlint sugar-runner sugar-runner-devel
sugar-runner.x86_64: W: spelling-error %description -l en_US fullscreen -> full screen, full-screen, firescreen
sugar-runner.x86_64: W: no-manual-page-for-binary sugar-runner
sugar-runner-devel.x86_64: W: no-documentation
2 packages and 0 specfiles checked; 0 errors, 3 warnings.
# echo 'rpmlint-done:'



Requires
--------
sugar-runner (rpmlib, GLIBC filtered):
    /bin/sh
    /usr/bin/python
    libX11.so.6()(64bit)
    libXrandr.so.2()(64bit)
    libc.so.6()(64bit)
    libglib-2.0.so.0()(64bit)
    rtld(GNU_HASH)
    sugar

sugar-runner-devel (rpmlib, GLIBC filtered):
    libsugarrunner.so.0()(64bit)
    sugar-runner(x86-64)



Provides
--------
sugar-runner:
    libsugarrunner.so.0()(64bit)
    sugar-runner
    sugar-runner(x86-64)

sugar-runner-devel:
    sugar-runner-devel
    sugar-runner-devel(x86-64)



Source checksums
----------------
http://download.sugarlabs.org/sources/sucrose/glucose/sugar-runner/sugar-runner-0.99.3.tar.xz :
  CHECKSUM(SHA256) this package     : f3ea5617f464b06cf524bc14a5721f89554bf7ba2cba49d215f5f2c66c62328f
  CHECKSUM(SHA256) upstream package : f3ea5617f464b06cf524bc14a5721f89554bf7ba2cba49d215f5f2c66c62328f


Generated by fedora-review 0.5.0 (920221d) last change: 2013-08-30
Command line :/usr/bin/fedora-review -b 997478
Buildroot used: fedora-18-x86_64
Active plugins: Generic, Shell-api, C/C++
Disabled plugins: Java, Python, SugarActivity, Perl, R, PHP, Ruby
Disabled flags: EPEL5, EXARCH, DISTTAG
Comment 6 Peter Robinson 2013-10-08 11:09:21 EDT
Thanks, will update the package to the comment before I commit it. Thanks for the review.

New Package GIT Request
=======================
Package Name: sugar-runner
Short Description: Sugar runner emulator for development
Owners: pbrobinson
Branches: F-19 F-20
InitialCC:
Comment 7 Jon Ciesla 2013-10-08 13:36:35 EDT
Git done (by process-git-requests).
Comment 8 Peter Robinson 2013-10-09 07:14:15 EDT
Just to confirm the following from discussions with upstream:
- all bits of the package are meant to be GPLv2+ and the LGPL was a mistake in licensing. This will be fixed in the next release 0.99.5
- FSF address will be updated in that release too

Thank you both for the review

Note You need to log in before you can comment on or make changes to this bug.